=== debian/changelog ===
cgreen (1.5.1-1build2) mantic; urgency=medium

  * No-change rebuild against current binutils.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 15 Jun 2023 21:10:05 +0000

cgreen (1.5.1-1build1) lunar; urgency=medium

  * No-change rebuild against current binutils.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 17 Feb 2023 04:54:30 +0000

cgreen (1.5.1-1) unstable; urgency=medium

  * Import new upstream release
  * Update symbols
  * d/controls:
    - Add libbfd-dev to build-deps

 -- SZ Lin (林上智) <szlin@debian.org>  Sat, 16 Apr 2022 21:46:26 +0800
